# This file is part of the digitalSTROM dsm-api library.
#
# Copyright (C) 2010 digitalSTROM.org, Schlieren, Switzerland
#
# digitalSTROM dsm-api library is free software: you can redistribute it and/or modify
# it under the terms of the GNU Lesser General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# digitalSTROM dsm-api library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU Lesser General Public License for more details.
#
# You should have received a copy of the GNU Lesser General Public License
# along with digitalSTROM dsm-api library. If not, see <http://www.gnu.org/licenses/>.

from CGenerator import *

def signature_swig(self):
    if self.name == "DSID" and self.type_size == 8 and self.type_count == 12:
        return "dsid_t InDSID"
    elif self.name == "dSUID" and self.type_size == 8 and self.type_count == 17:
        return "dsuid_t InDSUID"
    if self.name == "Name":
        out = "const uint8_t *InName"
    elif self.name == "Request" and self.type_count == 64512:
        out = "const uint8_t *InRequest"
    elif self.name == "Payload" and self.type_count == 64:
        out = "const uint8_t *InPayload"
    elif self.name == "Content":
        out = "const uint8_t *InContent"
    elif (self.type_count > 1):
        out = "const uint" + str(self.type_size) + "_t " + " *InArray" + str(self.type_count)
    else:
        out = "uint" + str(self.type_size) + "_t " + self.name
    return out
Parameter.signature_swig = signature_swig

def declare_by_reference_swig(self):
    if (self.type_count == 1):
        return "uint" + str(self.type_size) + "_t *Out"
    elif self.name == "Name":
        return "uint" + str(self.type_size) + "_t *OutName"
    elif self.name == "Payload":
        return "uint" + str(self.type_size) + "_t *OutPayload"
    elif self.name == "Response":
        return "uint" + str(self.type_size) + "_t *OutResponse"
    elif self.name == "DSID" and self.type_size == 8 and self.type_count == 12:
        return "dsid_t *dsid"
    elif self.name == "dSUID" and self.type_size == 8 and self.type_count == 17:
        return "dsuid_t *dsuid"
    else:
        return "uint" + str(self.type_size) + "_t *OutArray" + str(self.type_count)
Parameter.declare_by_reference_swig = declare_by_reference_swig


def call_signature_swig(self):
    out = "int " + self.name + "(DsmApiHandle_t handle, dsuid_t dSMdSUID"
    if self.request_params:
        out += ", " + ", ".join(map(lambda x: x.signature_swig(), self.request_params))
    if self.response_params:
        out += ", " + ", ".join(map(lambda x: x.declare_by_reference_swig(), self.response_params))
    out += ")"
    return out
ApiCall.call_signature_swig = call_signature_swig
